chiark / gitweb /
Shell bug: avoid local=$(....) as it defeats set -e
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 funcs: ${FUNCNAME[*]}
16 lines: ${BASH_LINENO[*]}
17 files: ${BASH_SOURCE[*]}
18 END
19         exit 16
20 }
21
22 trap 'test $? = 0 || t-report-failure' EXIT
23
24 t-filter-out-git-hyphen-dir
25
26 t-set-intree
27
28 : ${DGIT_TEST_DEBUG=-D}
29 export DGIT_TEST_DEBUG
30
31 export GIT_COMMITTER_DATE='1440253867 +0100'
32 export GIT_AUTHOR_DATE='1440253867 +0100'
33
34 root=`pwd`
35 troot=$root/tests
36 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
37
38 tmp=$ADTTMP
39 if [ x"$tmp" = x ]; then
40         mkdir -p tests/tmp
41         tmpbase=$troot/tmp
42         tmp=tests/tmp/$testname
43         rm -rf $tmp
44         mkdir $tmp
45 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
46         tmpbase="$DGIT_TEST_TMPBASE"
47 fi
48 cd $tmp
49
50 tmp=`pwd`
51
52 t-set-using-tmp
53
54 env -0 >$tmp/.save-env
55
56 ln -f $troot/ssh ssh
57
58 export DEBCHANGE_VENDOR=dpkg
59
60 mkdir -p $tmp/incoming
61 cat <<END >$tmp/dput.cf
62 [test-dummy]
63 method                  = local
64 incoming                = $tmp/incoming
65 run_dinstall            = 0
66 END
67
68 : ${t_archive_method:=aq}
69 : ${tagpfx:=archive/test-dummy}
70 : ${suitespecs:=sid:unstable}
71
72 t-git-next-date () {
73         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
74         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
75 }
76
77 t-expect-fail () {
78         local mpat="$1"; shift
79
80         set +o pipefail
81         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
82         local ps="${PIPESTATUS[*]}"
83         set -o pipefail
84
85         case $ps in
86         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
87         *" 0")  ;;
88         *)      fail "tee failed"  ;;
89         esac
90
91         t-grep-mpat "$mpat" $tmp/t.output
92 }
93
94 t-grep-mpat () {
95         local mpat="$1"
96         local file="$2"
97
98         local grepper=fgrep
99         case "$mpat" in
100         [A-Z]:*)
101                 case "$mpat" in
102                 E:*)    grepper=egrep   ;;
103                 F:*)    grepper=fgrep   ;;
104                 *)      fail "bad mpat prefix in $mpat";;
105                 esac
106                 mpat=${mpat#[A-Z]:}
107                 ;;
108         esac
109
110         $grepper -e "$mpat" "$file" ||
111                 fail "message not found"
112 }
113
114 t-expect-push-fail () {
115         local mpat="$1"; shift
116
117         local triedpush; triedpush=`git rev-parse HEAD`
118
119         t-reporefs pre-push
120         t-expect-fail "$mpat"  "$@"
121         t-reporefs post-push
122         diff $tmp/show-refs.{pre,post}-push
123
124         t-git-objects-not-present '' $triedpush
125
126         eval "$t_expect_push_fail_hook"
127 }
128
129 t-git-objects-not-present () {
130         # t-git-objects-not-present GITDIR|'' OBJID [...]
131         # specifying '' means the repo for package $p
132         local gitdir="${1-$dgitrepo}"
133         local obj
134         if ! [ -e "$gitdir" ]; then return; fi
135         for obj in "$@"; do
136                 GIT_DIR=$gitdir \
137                 t-expect-fail 'unable to find' \
138                 git cat-file -t $obj
139         done
140 }
141
142 t-reporefs () {
143         local whichoutput=$1; shift
144         local whichrepo=${1-$dgitrepo}
145         local outputfile="$tmp/show-refs.$whichoutput"
146         (set -e
147          exec >"$outputfile"
148          if test -d $whichrepo; then
149                 cd $whichrepo
150                 git show-ref |sort
151         fi)
152 }
153
154 t-untar () {
155         local tarfile=$1.tar
156         local edittree=$1.edit
157         if test -d "$edittree"; then
158                 cp -a "$edittree"/* .
159         else
160                 tar xf "$tarfile"
161         fi
162 }
163
164 t-worktree () {
165         rm -rf $p
166         t-untar $troot/worktrees/${p}_$1
167 }
168
169 t-select-package () {
170         p=$1
171         dgitrepo=$tmp/git/$p.git
172 }
173
174 t-git () {
175         t-select-package $1
176         v=$2
177         mkdir -p $tmp/git
178         local gs=$troot/git-srcs/${p}_$v.git
179         (set -e; cd $tmp/git; t-untar $gs)
180 }
181
182 t-git-none () {
183         mkdir -p $tmp/git
184         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
185 }
186
187 t-git-merge-base () {
188         git merge-base $1 $2 || test $? = 1
189 }
190
191 t-has-ancestor () {
192         # t-has-ancestor ANCESTOR
193         # (CHILD is implicit, HEAD)
194         local now;      now=`git rev-parse HEAD`
195         local ancestor; ancestor=`git rev-parse $1^{}`
196         local mbase;    mbase=`t-git-merge-base $ancestor $now`
197         if [ x$mbase != x$ancestor ]; then
198                 fail "not ff $ancestor..$now, $mbase != $ancestor"
199         fi
200 }
201
202 t-has-parent-or-is () {
203         # t-has-parent-or-is CHILD PARENT
204         local child=$1
205         local parent=$2
206         local parents
207         parents=$(git show --pretty=format:' %P %H ' "$child")
208         parent=$(git rev-parse "$parent~0")
209         case "$parents" in
210         *" $parent "*)  ;;
211         *)      fail "child $child lacks parent $parent" ;;
212         esac
213 }
214
215 t-prep-newpackage () {
216         t-select-package $1
217         v=$2
218         t-archive-none $p
219         t-git-none
220         t-worktree $v
221         cd $p
222         if ! git show-ref --verify --quiet refs/heads/master; then
223                 git branch -m dgit/sid master
224                 git remote rm dgit
225         fi
226         cd ..
227 }
228
229 t-archive-none () {
230         t-select-package $1
231         t-archive-none-$t_archive_method
232 }
233 t-archive-none-aq () {
234         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
235
236         : >$tmp/aq/suites
237         local jsondelim="["
238
239         local suitespec
240         for suitespec in $suitespecs; do
241                 local suite=${suitespec%%:*}
242                 local sname=${suitespec#*:}
243
244                 >$tmp/aq/package.$suite.$p
245                 t-aq-archive-updated $suite $p
246
247                 >$tmp/aq/package.new.$p
248                 t-aq-archive-updated new $p
249
250                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
251
252                 cat <<END >>$tmp/aq/suites
253 $jsondelim
254    {
255       "archive" : "ftp-master",
256       "codename" : "$suite",
257       "components" : [
258          "main",
259          "contrib",
260          "non-free"
261       ],
262       "name" : "$sname",
263       "dakname" : "$sname"
264 END
265
266                 jsondelim="   },"
267
268         done
269         cat <<END >>$tmp/aq/suites
270     }
271 ]
272 END
273 }
274
275 t-aq-archive-updated () {
276         local suite=$1
277         local p=$2
278         local suitedir=$tmp/aq/dsc_in_suite/$suite
279         mkdir -p $suitedir
280         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
281                 use JSON;
282                 use strict;
283                 our @v;
284                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
285                 push @v, {
286                         "version" => "$1",
287                         "sha256sum" => "$2",
288                         "component" => "$3",
289                         "filename" => "$4",
290                 };
291                 END {
292                         my $json = JSON->new->canonical();
293                         print $json->encode(\@v) or die $!;
294                 }
295         '
296 }
297
298 t-archive-process-incoming () {
299         local suite=$1
300         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
301         t-archive-query "$suite"
302 }
303
304 t-archive-query () {
305         local suite=${1-sid}
306         local dscf=main/${p}_${v}.dsc
307         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
308 }
309 t-archive-query-aq () {
310         local suite=$1
311         local p=$2
312         local v=$3
313         local dscf=$4
314         local sha; sha=`sha256sum <$tmp/mirror/pool/$dscf`
315         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
316         t-aq-archive-updated $suite $p
317 }
318
319 t-archive () {
320         t-archive-none $1
321         v=$2
322         local dscf=${p}_$2.dsc
323         rm -f $tmp/mirror/pool/main/${p}_*
324         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
325         t-archive-query $suite
326         rm -rf $tmp/extract
327         mkdir $tmp/extract
328         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
329 }
330
331 t-git-dir-time-passes () {
332         touch -d 'last year' $dgitrepo
333 }
334
335 t-git-dir-check () {
336         local gitdir=$dgitrepo
337         case "$1" in
338         enoent)
339                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
340                 return
341                 ;;
342         public) wantstat='7[75]5' ;;
343         secret) wantstat='7[70]0' ;;
344         *)      fail "$1 t-git-dir-check ?" ;;
345         esac
346         gotstat=`stat -c%a $gitdir`
347         case "$gotstat" in
348         *$wantstat) return ;;
349         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
350         esac
351 }
352
353 t-expect-fsck-fail () {
354         echo >>$tmp/fsck.expected-errors "$1"
355 }
356
357 t-git-fsck () {
358         set +e
359         LC_MESSAGES=C git fsck --no-dangling --strict 2>&1 \
360                 | tee dgit-test-fsck.errs
361         ps="${PIPESTATUS[*]}"
362         set -e
363
364         local pats
365         if [ -f $tmp/fsck.expected-errors ]; then
366                 pats=(-w -f $tmp/fsck.expected-errors)
367         else
368                 test "$ps" = "0 0"
369         fi
370         pats+=(-e 'notice: HEAD points to an unborn branch')
371         pats+=(-e 'notice: No default references')
372
373         set +e
374         grep -v "${pats[@]}" dgit-test-fsck.errs
375         rc=$?
376         set -e
377         case $rc in
378         1) ;; # no unexpected errors
379         0) fail "unexpected messages from git-fsck" ;;
380         *) fail "grep of git-fsck failed" ;;
381         esac
382 }
383
384 t-fscks () {
385         (
386         shopt -s nullglob
387         for d in $tmp/*/.git $tmp/git/*.git; do
388                 cd "$d"
389                 t-git-fsck
390         done
391         )
392 }
393
394 t-ok () {
395         t-fscks
396         echo ok.
397 }
398
399 t-rm-dput-dropping () {
400         rm -f $tmp/${p}_${v}_*.upload
401 }
402
403 t-dgit () {
404         local dgit=${DGIT_TEST-dgit}
405         pwd
406         : '
407 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
408         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
409                 -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
410                 -k39B13D8A $t_dgit_xopts "$@"
411         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
412 '
413 }
414
415 t-diff-nogit () {
416         diff --exclude=.git --exclude=.pc -ruN $*
417 }
418
419 t-files-notexist () {
420         local f
421         for f in "$@"; do
422                 if [ -e $f ]; then
423                         fail "$f exists!"
424                 fi
425         done
426 }
427
428 t-cloned-fetched-good () {
429         t-diff-nogit ../extract/$p-${v%-*} .
430         t-clean-on-branch dgit/sid
431         t-refs-same-start
432         t-refs-same \
433                 refs/heads/dgit/sid \
434                 refs/remotes/dgit/dgit/sid
435         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
436 }
437
438 t-output () {
439         printf "%s${1:+\n}" "$1" >$tmp/t.want
440         shift
441         "$@" >$tmp/t.got
442         diff $tmp/t.want $tmp/t.got
443 }
444
445 t-clean-on-branch () {
446         t-output "## $1" git status -b --porcelain
447 }
448
449 t-setup-done () {
450         local savevars=$1
451         local savedirs=$2
452         local importeval=$3
453
454         local import=IMPORT.${0##*/}
455         exec 4>$tmp/$import.new
456
457         local vn
458         for vn in $savevars; do
459                 perl >&4 -I. -MDebian::Dgit -e '
460                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
461                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
462         done
463
464         (set -e; cd $tmp; tar cf $import.tar $savedirs)
465
466         printf >&4 "\n%s\n" "$importeval"
467
468         mv -f $tmp/$import.new $tmp/$import
469 }
470
471 t-setup-import () {
472         local setupname=$1
473
474         local setupsrc
475         local lock
476         if [ "x$tmpbase" = x ]; then
477                 # ADTTMP was set on entry to tests/lib, so we
478                 # are not sharing tmp area between tests
479                 setupsrc="$tmp"
480                 lock="$tmp/.dummy.lock"
481         else
482                 setupsrc="$tmpbase/$setupname"
483                 lock="$setupsrc.lock"
484         fi
485
486         local simport="$setupsrc/IMPORT.$setupname"
487
488         if ! [ -e "$simport" ]; then
489                 with-lock-ex -w "$lock" \
490                 xargs -0 -a $tmp/.save-env \
491                 bash -xec '
492                         cd "$1"; shift
493                         setupname="$1"; shift
494                         simport="$1"; shift
495                         if [ -e "$simport" ]; then exit 0; fi
496                         env - "$@" \
497                         "tests/setup/$setupname"
498                 ' x "$root" "$setupname" "$simport"
499         fi
500
501         if [ "x$setupsrc" != "x$tmp" ]; then
502                 (set -e; cd $tmp; tar xf "$simport.tar")
503         fi
504
505         . "$simport"
506 }
507
508 t-git-get-ref-exact () {
509         local ref=$1
510         # does not dereference, unlike t-git-get-ref
511         case "$ref" in
512         refs/*) ;;
513         *) fail "t-git-get-ref-exact bad $ref" ;;
514         esac
515         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
516 }
517
518 t-git-get-ref () {
519         local ref=$1
520         case "$ref" in
521         refs/*) ;;
522         *) fail "t-git-get-ref bad $ref" ;;
523         esac
524         (git show-ref -d $1 || test $? = 1) | perl -ne '
525                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
526                 END { print "$x\n" if length $x; }
527         '
528 }
529
530 t-ref-same-exact () {
531         local name="$1"
532         local val; val=`t-git-get-ref-exact $name`
533         t-ref-same-val "$name" $val
534 }
535
536 t-ref-same () {
537         local name="$1"
538         local val; val=`t-git-get-ref $name`
539         t-ref-same-val "$name" $val
540 }
541
542 t-ref-head () {
543         local val; val=`git rev-parse HEAD`
544         t-ref-same-val HEAD $val
545 }
546
547 t-ref-same-val () {
548         local name="$1"
549         local val=$2
550         case "${t_ref_val-unset}" in
551         unset)          ;;
552         "$val")         ;;
553         *)              fail "ref varies: ($name)\
554  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
555         esac
556         t_ref_val="$val"
557         t_ref_names+=("$name")
558 }
559
560 t-refs-same-start () {
561         unset t_ref_val
562         t_ref_names=()
563 }
564
565 t-refs-same () {
566         local g
567         for g in $*; do
568                 t-ref-same $g
569         done
570 }
571
572 t-refs-notexist () {
573         local val
574         for g in $*; do
575                 val=`t-git-get-ref $g`
576                 if [ "x$val" != x ]; then
577                         fail "ref $g unexpectedly exists ($val)"
578                 fi
579         done
580 }
581
582 t-v-tag () {
583         echo refs/tags/$tagpfx/${v//\~/_}
584 }
585
586 t-format-ref () {
587         git log -n1 --pretty=format:"$1" "$2"
588 }
589
590 t-sametree-parent () {
591         local ref=$1
592         local parent
593         local ctree; ctree=$(t-format-ref '%T' "$ref")
594         while :; do
595                 local psame=''
596                 for parent in $(t-format-ref '%P' "$ref"); do
597                         local ptree; ptree=$(t-format-ref '%T' "$parent")
598                         if [ "x$ptree" = "x$ctree" ]; then
599                                 psame+=" $parent"
600                         fi
601                 done
602                 case "$psame" in ""|" * *") break ;; esac
603                 ref="${psame# }"
604         done
605         echo "$ref"
606 }
607
608 t-check-pushed-master () {
609         local master; master=`t-git-get-ref refs/heads/master`
610         if [ x$master = x$t_ref_val ]; then return; fi
611         if [ x$master = x ]; then fail "failed to push master"; fi
612         # didn't update master, it must be not FF
613         local mbase; mbase=`t-git-merge-base $master $t_ref_val`
614         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
615 }
616
617 t-pushed-good () {
618         local branch=$1
619         local suite=${2:-sid}
620         t-refs-same \
621                 refs/heads/$branch
622         t-pushed-good-core
623 }
624         
625 t-pushed-good-core () {
626         t-ref-dsc-dgit
627         t-refs-same \
628                 `t-v-tag` \
629                 refs/remotes/dgit/dgit/$suite
630         t-refs-notexist \
631                 refs/heads/dgit/unstable \
632                 refs/remotes/dgit/dgit/unstable
633         (set -e; cd $dgitrepo
634          t-refs-same \
635                 refs/dgit/$suite \
636                 `t-v-tag`
637          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
638          t-refs-notexist \
639                 refs/dgit/unstable
640         )
641         git verify-tag `t-v-tag`
642 }
643
644 t-splitbrain-pushed-good--unpack () {
645         cd $tmp
646         rm -rf t-unpack
647         mkdir t-unpack
648         cd t-unpack
649         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
650         ln -s $tmp/incoming/*.orig*.tar* . ||:
651         ln -s $incoming_dsc .
652         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
653         dpkg-source "$@" -x *.dsc
654         cd */.
655         git init
656         git fetch ../../$p "refs/tags/*:refs/tags/*"
657 }
658
659 t-splitbrain-pushed-good--checkprep () {
660         git add -Af .
661         git rm --cached -r --ignore-unmatch .pc
662 }
663
664 t-splitbrain-pushed-good--checkdiff () {
665         local tag=$1
666         t-splitbrain-pushed-good--checkprep
667         t-output "" git diff --stat --cached $tag
668 }
669
670 t-splitbrain-pushed-good-start () {
671         dep14tag=refs/tags/test-dummy/${v//\~/_}
672         dgittag=$(t-v-tag)
673         t-output "" git status --porcelain
674         t-ref-head
675         t-refs-same $dep14tag
676         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
677         git merge-base --is-ancestor $dep14tag $dgittag
678
679         t-refs-same-start
680         t-ref-same refs/heads/split.p
681         case "$(t-git-get-ref refs/heads/split.b)" in
682         "$t_ref_val") ;;
683         "$(git rev-parse refs/heads/split.p^0)") ;;
684         "$(git rev-parse refs/heads/split.p^1)") ;;
685         *) fail 'bad b/p' ;;
686         esac
687         t-pushed-good-core
688
689         t-incoming-dsc
690
691         t-splitbrain-pushed-good--unpack
692         t-splitbrain-pushed-good--checkdiff $dgittag
693 }
694 t-splitbrain-pushed-good-end-made-dep14 () {
695         t-splitbrain-pushed-good--checkdiff $dep14tag
696         cd $tmp/$p
697 }
698
699 t-splitbrain-rm-gitignore-patch () {
700         perl -i -pe '
701                 next unless $_ eq "auto-gitignore\n";
702                 die if $counter++;
703                 chomp;
704                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
705                 $_ = "";
706         ' debian/patches/series
707 }
708
709 t-gbp-pushed-good () {
710         local suite=${1:-sid}
711         t-splitbrain-pushed-good-start
712
713         # Right, now we want to check that the maintainer tree and
714         # the dgit tree differ in exactly the ways we expect.  We
715         # achieve this by trying to reconstruct the maintainer tree
716         # from the dgit tree.
717
718         # So, unpack it withut the patches applied
719         t-splitbrain-pushed-good--unpack --skip-patches
720
721         # dgit might have added a .gitignore patch, which we need to
722         # drop and remove
723         t-splitbrain-rm-gitignore-patch
724
725         # Now the result should differ only in non-debian/ .gitignores
726         t-splitbrain-pushed-good--checkprep
727         git diff --cached --name-only $dep14tag >../changed
728         perl -ne '
729                 next if !m#^debian/# && m#(^|/)\.gitignore#;
730                 die "$_ mismatch";
731         ' <../changed
732
733         # If we actually apply the gitignore patch by hand, it
734         # should be perfect:
735         if [ -f ../t-auto-gitignore ]; then
736                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
737         fi
738
739         t-splitbrain-pushed-good-end-made-dep14
740 }
741
742 t-unapplied-pushed-good () {
743         t-splitbrain-pushed-good-start
744         t-splitbrain-pushed-good--unpack --skip-patches
745         t-splitbrain-pushed-good-end-made-dep14
746 }
747
748 t-dpm-pushed-good () {
749         t-splitbrain-pushed-good-start
750         t-splitbrain-pushed-good--unpack
751         t-splitbrain-rm-gitignore-patch
752         t-splitbrain-pushed-good-end-made-dep14
753 }
754
755 t-commit-build-push-expect-log () {
756         local msg=$1
757         local mpat=$2
758         t-commit "$msg"
759         t-dgit build
760         LC_MESSAGES=C \
761         t-dgit push --new 2>&1 |tee $tmp/push.log
762         t-grep-mpat "$mpat" $tmp/push.log
763 }
764
765 t-822-field () {
766         local file=$1
767         local field=$2
768         perl -e '
769                 use Dpkg::Control::Hash;
770                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
771                 $h->parse(\*STDIN,"'"$file"'");
772                 my $val = $h->{"'$field'"},"\n";
773                 die "'"$file $field"'" unless defined $val;
774                 print $val,"\n";
775         ' <$file
776 }
777
778 t-stunt-envvar () {
779         local var=$1
780         local tstunt=$2
781         eval '
782                 case "$'$var'" in
783                 "$tstunt:"*)    ;;
784                 *":$tstunt:"*)  ;;
785                 "")             '$var'="$tstunt" ;;
786                 *)              '$var'="$tstunt:$'$var'" ;;
787                 esac
788                 export '$var'
789         '
790 }
791
792 t-tstunt () {
793         local tstunt=$tmp/tstunt
794         t-stunt-envvar PATH $tstunt
795         t-stunt-envvar PERLLIB $tstunt
796         local f
797         for f in "$@"; do
798                 f="./$f"
799                 local d="$tstunt/${f%/*}"
800                 mkdir -p $d
801                 ln -sf "$troot/tstunt/$f" "$d"/.
802         done
803 }
804
805 t-tstunt-parsechangelog () {
806         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
807 }
808
809 t-tstunt-lintian () {
810         t-tstunt lintian
811 }
812
813 t-tstunt-debuild () {
814         : ${DGIT_TEST_REAL_DEBUILD:=$(type -p debuild)}
815         export DGIT_TEST_REAL_DEBUILD
816         t-tstunt debuild
817 }
818
819 t-incoming-dsc () {
820         local dsc=${p}_${v}.dsc
821         incoming_dsc=$tmp/incoming/$dsc
822 }
823
824 t-ref-dsc-dgit () {
825         t-incoming-dsc
826         local val; val=`t-822-field $incoming_dsc Dgit`
827         perl -e '$_=shift @ARGV; die "Dgit $_ ?" unless m/^\w+\b/;' "$val"
828         t-ref-same-val $incoming_dsc "$val"
829 }
830
831 t-apply-diff () {
832         local v1=$1
833         local v2=$2
834         (cd $troot/pkg-srcs;
835          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
836          | patch -p1 -u
837 }
838
839 t-gbp-unapplied-pq2qc () {
840         # does `gbp pq export'
841         # commits the resulting debian/patches on  qc/BRANCH
842         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
843         # qc/BRANCH is not fast-forwarding
844
845         gbp pq export
846
847         branch=`git symbolic-ref HEAD`
848         branch=${branch#refs/heads/}
849
850         case "$branch" in
851         */*) fail "unexpected branch $branch" ;;
852         esac
853
854         git branch -f qc/$branch
855         git checkout qc/$branch
856         git add debian/patches
857         git commit -m 'Commit patch queue'
858 }
859
860 t-git-pseudo-merge () {
861         # like   git merge -s ours
862         if [ ! "$git_pseuomerge_opts" ]; then
863                 if git merge --help \
864                  | grep -q allow-unrelated-histories; then
865                         git_pseuomerge_opts='--allow-unrelated-histories'
866                 fi
867                 git_pseuomerge_opts+=' -s ours'
868         fi
869         git merge $git_pseuomerge_opts "$@"
870 }
871
872 t-gbp-example-prep-no-ff () {
873         t-tstunt-parsechangelog
874         t-archive example 1.0-1
875         t-git-none
876         t-worktree 1.0
877
878         cd example
879
880         t-dgit fetch
881
882         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
883         gbp pq rebase
884
885         echo '/* some comment */' >>src.c
886         git add src.c
887         git commit -m 'Add a comment to an upstream file'
888
889         t-gbp-unapplied-pq2qc
890
891         t-commit 'some updates' 1.0-2
892 }
893
894 t-gbp-example-prep () {
895         t-gbp-example-prep-no-ff
896
897         t-git-pseudo-merge \
898                 -m 'Pseudo-merge to make descendant of archive' \
899                 remotes/dgit/dgit/sid
900 }
901
902 t-make-badcommit () {
903         badcommit=$(
904                 git cat-file commit HEAD | \
905                 perl -pe 's/^committer /commiter /' | \
906                 git hash-object -w -t commit --stdin
907         )
908         t-expect-fsck-fail $badcommit
909 }
910
911 t-commit () {
912         local msg=$1
913         v=${2:-${majorv:-1}.$revision}
914         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
915         git add debian/changelog
916         debcommit
917         revision=$(( ${revision-0} + 1 ))
918 }
919
920 t-git-config () {
921         git config --global "$@"
922 }
923
924 t-drs () {
925         export DGIT_TEST_TROOT=$troot
926  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
927  t-git-config dgit-distro.test-dummy.git-check true
928  t-git-config dgit-distro.test-dummy.git-create true
929  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
930         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
931         cp $troot/suites $tmp/.
932         cp $troot/suites $tmp/suites-master
933
934         export t_check_pushed_master=t-check-pushed-master
935
936         drs_dispatch=$tmp/distro=test-dummy
937         mkdir $drs_dispatch
938
939         if [ "x$DGIT_TEST_INTREE" != x ]; then
940                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
941         fi
942
943         ln -sf $tmp/git $drs_dispatch/repos
944         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
945         mkdir -p $drs_dispatch/keyrings
946         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
947         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
948         ln -sf /bin/true $drs_dispatch/policy-hook
949 }
950
951 t-newtag () {
952  export tagpfx=archive/test-dummy
953  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
954 }
955 t-oldtag () {
956  export tagpfx=test-dummy
957  t-git-config dgit-distro.test-dummy.dgit-tag-format old
958 }
959
960 t-dsd () {
961         t-drs
962  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
963  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
964  t-git-config dgit-distro.test-dummy.git-create true
965  t-git-config dgit-distro.test-dummy.git-url \
966                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
967
968  t-git-config dgit-distro.test-dummy.diverts.drs /drs
969  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
970  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
971  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
972  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
973
974         echo 'no-such-package* drs' >$drs_dispatch/diverts
975 }
976
977 t-policy-admin () {
978         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
979 }
980
981 t-policy-nonexist () {
982         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
983 }
984
985 t-make-hook-link () {
986         local hook=$1 # in infra/
987         local linkpath=$2
988         hook=${DGIT_INFRA_PFX}$hook
989         case $hook in
990         */*)    ;;
991         *)      hook=`type -P $hook` ;;
992         esac
993         ln -sf "$hook" $linkpath
994 }
995
996 t-policy () {
997         local policyhook=$1
998         t-make-hook-link $policyhook $drs_dispatch/policy-hook
999 }
1000
1001 t-debpolicy () {
1002         t-dsd
1003         t-policy dgit-repos-policy-debian
1004
1005         mkdir $tmp/git
1006         t-policy-admin create-db
1007 }
1008
1009 t-policy-periodic () {
1010         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
1011                 test-dummy $drs_dispatch '' --cron
1012 }
1013
1014 t-restrict () {
1015         local restriction=$1
1016         (cd $root; t-restriction-$restriction >&2)
1017 }
1018
1019 t-dependencies () {
1020         : "Hopefully installed: $*"
1021 }
1022
1023 t-chain-test () {
1024         local ct=$1
1025         local d=${0%/*}
1026         cd $root
1027         export DGIT_TEST_TESTNAME="$testname"
1028         export DGIT_TEST_TMPBASE="$tmpbase"
1029         export ADTTMP=$tmp
1030         exec "$d/$ct"
1031 }       
1032
1033 t-alt-test () {
1034         local t=${0##*/}
1035         t-${t%%-*}
1036         t-chain-test "${t#*-}"
1037 }
1038
1039 case "$0" in
1040 */gnupg) ;;
1041 *)      t-setup-import gnupg    ;;
1042 esac